"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Statement = /** @class */ (function () {
    function Statement() {
        this.Operation = "";
        this.Table = "";
        this.Text = "";
        this.Values = [];
    }
    Statement.prototype.join = function (table, fields, type) {
        if (type === void 0) { type = "INNER"; }
        var expression = Object.entries(fields).map(function (v, k) { return v[0] + " = " + v[1]; });
        this.Text += " " + type + " JOIN " + table + " ON " + expression.join(' AND ');
        return this;
    };
    Statement.prototype.where = function (fields) {
        var _this = this;
        var expression = Object.keys(fields).map(function (v, k) { return v + " = $" + (k + _this.Values.length + 1); });
        this.Values = this.Values.concat(Object.values(fields));
        this.Text += " WHERE " + expression.join(' AND ');
        return this;
    };
    Statement.prototype.groubby = function (columns) {
        this.Text += " GROUB BY " + columns.join(', ');
        return this;
    };
    Statement.prototype.having = function (fields) {
        var _this = this;
        var expression = Object.keys(fields).map(function (v, k) { return v + " = $" + (k + _this.Values.length + 1); });
        this.Values = this.Values.concat(Object.values(fields));
        this.Text += " HAVING " + expression.join(' AND ');
        return this;
    };
    Statement.prototype.orderby = function (columns) {
        this.Text += " ORDER BY " + columns.join(', ');
        return this;
    };
    Statement.prototype.returning = function (columns) {
        this.Text += " RETURNING " + columns.join(', ');
        return this;
    };
    return Statement;
}());
exports.Statement = Statement;
function select(table, columns) {
    var statement = new Statement();
    statement.Operation = "SELECT";
    statement.Table = table;
    statement.Text = "SELECT " + columns.join(', ') + " FROM " + table;
    return statement;
}
exports.select = select;
function insert(table, fields) {
    var columns = Object.keys(fields);
    var values = Object.values(fields).map(function (v, k) { return "$" + (k + 1); });
    var statement = new Statement();
    statement.Operation = "INSERT";
    statement.Table = table;
    statement.Values = Object.values(fields);
    statement.Text = "INSERT INTO " + table + " (" + columns.join(", ") + ") VALUES (" + values.join(", ") + ")";
    return statement;
}
exports.insert = insert;
function update(table, fields) {
    var columns = Object.keys(fields).map(function (v, k) { return v + " = $" + (k + 1); });
    var statement = new Statement();
    statement.Operation = "UPDATE";
    statement.Table = table;
    statement.Values = Object.values(fields);
    statement.Text = "UPDATE " + table + " SET " + columns.join(", ");
    return statement;
}
exports.update = update;
function deletes(table) {
    var statement = new Statement();
    statement.Operation = "DELETE";
    statement.Table = table;
    statement.Text = "DELETE FROM " + table;
    return statement;
}
exports.deletes = deletes;
//# sourceMappingURL=index.js.map